Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 1958895

Summary: Review Request: python-socks - Core proxy (SOCKS4, SOCKS5, HTTP tunneling) functionality for Python
Product: [Fedora] Fedora Reporter: Ankur Sinha (FranciscoD) <sanjay.ankur>
Component: Package ReviewAssignee: Karolina Surma <ksurma>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: ksurma, mhroncok, package-review
Target Milestone: ---Flags: ksurma: fedora-review+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2021-05-20 01:11:18 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On:    
Bug Blocks: 1958867    

Description Ankur Sinha (FranciscoD) 2021-05-10 11:42:55 UTC
Spec URL: https://ankursinha.fedorapeople.org/python-socks/python-socks.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-socks/python-socks-1.2.4-1.fc34.src.rpm

Description:
The python-socks package provides a core proxy client functionality for Python.
Supports SOCKS4(a), SOCKS5, HTTP (tunneling) proxy and provides sync and async
(asyncio, trio, curio) APIs. It is used internally by aiohttp-socks and
httpx-socks packages.


Fedora Account System Username: ankursinha

Comment 1 Karolina Surma 2021-05-10 13:34:05 UTC
Hi Ankur,

I have a few remarks regarding the package.

- Tests
If there are tests in the upstream, they should be run in the build process. 
As they're not present in PyPI tarball, it'd be better to use the archive from GitHub as Source. 
Then %bcond_with can be removed entirely.
Tests should be run using %pytest macro.

- Extras
The package in the upstream provides extras: asyncio, curio and trio. 
python-socks[asyncio] is required by the blocked python-aiohttp-socks so at least this one should be provided.
Please refer to this site for details how to define extras: https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_python_extras

- Nitpicks
1) Consider removing name macros: 
%global modname socks
%global pypi_name python-%{modname}
%global undername python_%{modname}
They make the spec file less readable. It'd be nicer to copy&paste URL directly. 
'modname' doesn't mean module name, so if you decide to keep them, it'd be better to rename to something like 'basename'.


2) There is a section in prep commented out - if it's not used, it should be removed.

# Comment out to remove /usr/bin/env shebangs
# Can use something similar to correct/remove /usr/bin/python shebangs also
# find . -type f -name "*.py" -exec sed -i '/^#![  ]*\/usr\/bin\/env.*$/ d' {} 2>/dev/null ';'


I'll continue with the full review on the updated files.

Comment 2 Ankur Sinha (FranciscoD) 2021-05-10 15:41:53 UTC
Hi Karolina,

Thanks very much for your review. Here are the updated spec/srpm:

Spec URL: https://ankursinha.fedorapeople.org/python-socks/python-socks.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-socks/python-socks-1.2.4-1.fc34.src.rpm

Changelog:

* Mon May 10 2021 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 1.2.4-1
- Use github tar
- Enable all tests and remove conditional
- Provide meta packages for extras
- Remove unneeded comments
- Remove weak deps: included by the automatic dep generator in extra sub-packages

Cheers,
Ankur

Comment 3 Ankur Sinha (FranciscoD) 2021-05-10 15:43:07 UTC
Please note: "basename" is used by RPM already, so I've left it as "modname". I really couldn't think of a better term to use :/.

Comment 4 Miro Hrončok 2021-05-10 16:44:00 UTC
The module name is python_socks, so %modname = socks is a really weird choice. Wouldn't it be easier to use the actual string in the spec?

Comment 5 Ankur Sinha (FranciscoD) 2021-05-10 17:39:41 UTC
It won't make so much of a difference to me while maintaining the package, but sure. Here you go:

Spec URL: https://ankursinha.fedorapeople.org/python-socks/python-socks.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-socks/python-socks-1.2.4-1.fc34.src.rpm

* Mon May 10 2021 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 1.2.4-1
- do not use modname as a variable


Cheers,

Comment 6 Miro Hrončok 2021-05-10 17:49:22 UTC
Thanks! It makes a difference for us as provenpackagers / Python maintainers when we need to read or adapt the spec.


The next thing is just a tip:

%{?python_extras_subpkg:%python_extras_subpkg -n python3-socks -i %{python3_sitelib}/*.egg-info asyncio}
%{?python_extras_subpkg:%python_extras_subpkg -n python3-socks -i %{python3_sitelib}/*.egg-info curio}
%{?python_extras_subpkg:%python_extras_subpkg -n python3-socks -i %{python3_sitelib}/*.egg-info trio}

This can be replaced with

%{?python_extras_subpkg:
%python_extras_subpkg -n python3-socks -i %{python3_sitelib}/*.egg-info asyncio
%python_extras_subpkg -n python3-socks -i %{python3_sitelib}/*.egg-info curio
%python_extras_subpkg -n python3-socks -i %{python3_sitelib}/*.egg-info trio
}

Or even:

%{?python_extras_subpkg:%python_extras_subpkg -n python3-socks -i %{python3_sitelib}/*.egg-info asyncio curio trio}


I let Karolina run the automated checks tmrw.

Comment 7 Ankur Sinha (FranciscoD) 2021-05-10 17:57:03 UTC
Ah, right. I've updated the spec to use the single line version now:

Spec URL: https://ankursinha.fedorapeople.org/python-socks/python-socks.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-socks/python-socks-1.2.4-1.fc34.src.rpm

* Mon May 10 2021 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 1.2.4-1
- use single line extras macro invocation


Cheers,

Comment 8 Karolina Surma 2021-05-11 07:35:08 UTC
Thanks!

Just two nitpicks:
"rm -rf %{undername}.egg-info" in %prep is not necessary, the source tarball doesn't have any egg-info's.

There are two writing conventions mixed in BuildRequires, I'd go for better readability and unify them. But technically it doesn't make a difference
BuildRequires:  %{py3_dist pytest}
BuildRequires:  python3-pytest-asyncio


Those are not blockers, the package is APPROVED.


Full Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* Apache License 2.0". 77
     files have unknown license. Detailed output of licensecheck in
     /home/ksurma/tmp/1958895-python-socks/licensecheck.txt
[-]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-socks-1.2.4-1.fc35.noarch.rpm
          python3-socks+asyncio-1.2.4-1.fc35.noarch.rpm
          python3-socks+curio-1.2.4-1.fc35.noarch.rpm
          python3-socks+trio-1.2.4-1.fc35.noarch.rpm
          python-socks-1.2.4-1.fc35.src.rpm
python3-socks.noarch: W: spelling-error %description -l en_US async -> sync, a sync
python3-socks.noarch: W: spelling-error %description -l en_US aiohttp 
python3-socks.noarch: W: spelling-error %description -l en_US httpx -> HTTP
python3-socks+asyncio.noarch: W: spelling-error Summary(en_US) Metapackage -> Meta package, Meta-package, Prepackage
python3-socks+asyncio.noarch: W: spelling-error Summary(en_US) asyncio -> syncopation
python3-socks+asyncio.noarch: W: spelling-error %description -l en_US metapackage -> meta package, meta-package, prepackage
python3-socks+asyncio.noarch: W: spelling-error %description -l en_US asyncio -> syncopation
python3-socks+asyncio.noarch: W: no-documentation
python3-socks+curio.noarch: W: spelling-error Summary(en_US) Metapackage -> Meta package, Meta-package, Prepackage
python3-socks+curio.noarch: W: spelling-error %description -l en_US metapackage -> meta package, meta-package, prepackage
python3-socks+curio.noarch: W: no-documentation
python3-socks+trio.noarch: W: spelling-error Summary(en_US) Metapackage -> Meta package, Meta-package, Prepackage
python3-socks+trio.noarch: W: spelling-error %description -l en_US metapackage -> meta package, meta-package, prepackage
python3-socks+trio.noarch: W: no-documentation
python-socks.src: W: spelling-error %description -l en_US async -> sync, a sync
python-socks.src: W: spelling-error %description -l en_US asyncio -> syncopation
python-socks.src: W: spelling-error %description -l en_US aiohttp 
python-socks.src: W: spelling-error %description -l en_US httpx -> HTTP
5 packages and 0 specfiles checked; 0 errors, 18 warnings.




Rpmlint (installed packages)
----------------------------
python3-socks+asyncio.noarch: W: spelling-error Summary(en_US) Metapackage -> Meta package, Meta-package, Prepackage
python3-socks+asyncio.noarch: W: spelling-error Summary(en_US) asyncio -> syncopation
python3-socks+asyncio.noarch: W: spelling-error %description -l en_US metapackage -> meta package, meta-package, prepackage
python3-socks+asyncio.noarch: W: spelling-error %description -l en_US asyncio -> syncopation
python3-socks+asyncio.noarch: W: no-documentation
python3-socks+trio.noarch: W: spelling-error Summary(en_US) Metapackage -> Meta package, Meta-package, Prepackage
python3-socks+trio.noarch: W: spelling-error %description -l en_US metapackage -> meta package, meta-package, prepackage
python3-socks+trio.noarch: W: no-documentation
python3-socks+curio.noarch: W: spelling-error Summary(en_US) Metapackage -> Meta package, Meta-package, Prepackage
python3-socks+curio.noarch: W: spelling-error %description -l en_US metapackage -> meta package, meta-package, prepackage
python3-socks+curio.noarch: W: no-documentation
python3-socks.noarch: W: spelling-error %description -l en_US async -> sync, a sync
python3-socks.noarch: W: spelling-error %description -l en_US aiohttp 
python3-socks.noarch: W: spelling-error %description -l en_US httpx -> HTTP
4 packages and 0 specfiles checked; 0 errors, 14 warnings.



Source checksums
----------------
https://github.com/romis2012/python-socks/archive/v1.2.4/python-socks-1.2.4.tar.gz :
  CHECKSUM(SHA256) this package     : a7a996f90238c91be047839d887ea6ef4cb0c3c33120bf07a62d5ea56aca27d3
  CHECKSUM(SHA256) upstream package : a7a996f90238c91be047839d887ea6ef4cb0c3c33120bf07a62d5ea56aca27d3


Requires
--------
python3-socks (rpmlib, GLIBC filtered):
    python(abi)

python3-socks+asyncio (rpmlib, GLIBC filtered):
    python(abi)
    python3-socks
    python3.9dist(async-timeout)

python3-socks+curio (rpmlib, GLIBC filtered):
    python(abi)
    python3-socks
    python3.9dist(curio)

python3-socks+trio (rpmlib, GLIBC filtered):
    python(abi)
    python3-socks
    python3.9dist(trio)



Provides
--------
python3-socks:
    python-socks
    python3-socks
    python3.9-socks
    python3.9dist(python-socks)
    python3dist(python-socks)

python3-socks+asyncio:
    python-socks+asyncio
    python3-socks+asyncio
    python3.9-socks+asyncio
    python3.9dist(python-socks[asyncio])
    python3dist(python-socks[asyncio])

python3-socks+curio:
    python-socks+curio
    python3-socks+curio
    python3.9-socks+curio
    python3.9dist(python-socks[curio])
    python3dist(python-socks[curio])

python3-socks+trio:
    python-socks+trio
    python3-socks+trio
    python3.9-socks+trio
    python3.9dist(python-socks[trio])
    python3dist(python-socks[trio])

Comment 9 Ankur Sinha (FranciscoD) 2021-05-11 09:39:03 UTC
Many thanks for your review Karolina. I've made the remaining tweaks and requested SCM.

Comment 10 Gwyn Ciesla 2021-05-11 13:30:51 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-socks

Comment 11 Fedora Update System 2021-05-11 14:57:44 UTC
FEDORA-2021-b70cc246ad has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2021-b70cc246ad

Comment 12 Fedora Update System 2021-05-11 14:57:47 UTC
FEDORA-2021-d07dc64d18 has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-d07dc64d18

Comment 13 Fedora Update System 2021-05-12 06:50:16 UTC
FEDORA-2021-b70cc246ad has been pushed to the Fedora 33 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-b70cc246ad \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-b70cc246ad

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 14 Fedora Update System 2021-05-12 07:05:21 UTC
FEDORA-2021-d07dc64d18 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-d07dc64d18 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-d07dc64d18

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 15 Fedora Update System 2021-05-20 01:11:18 UTC
FEDORA-2021-d07dc64d18 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 16 Fedora Update System 2021-05-20 01:14:59 UTC
FEDORA-2021-b70cc246ad has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.